<?php
// Version: 2.0; SPortal

// Admin General
$txt['sp-adminCatHelp'] = 'Here you can manage SimplePortal.';
$txt['sp-adminCatDesc'] = 'Here you can manage SimplePortal.';
$txt['sp-adminGeneralSettingsName'] = 'General Settings';
$txt['sp-adminGeneralSettingsDesc'] = 'Here you can manage the general settings.';
$txt['sp-adminBlockListName'] = 'Block List';
$txt['sp-adminBlockListDesc'] = 'Here you can manage portal blocks.';
$txt['sp-adminBlockAddName'] = 'Add Block';
$txt['sp-adminBlockAddDesc'] = 'Here you can add new blocks to portal.';
$txt['sp-adminArticleListName'] = 'Article List';
$txt['sp-adminArticleListDesc'] = 'Here you can manage articles.';
$txt['sp-adminArticleAddName'] = 'Add Article';
$txt['sp-adminArticleAddDesc'] = 'Here you can add new articles to categories.';
$txt['sp-adminCategoryListName'] = 'Category List';
$txt['sp-adminCategoryListDesc'] = 'Here you can manage article categories.';
$txt['sp-adminCategoryAddName'] = 'Add Category';
$txt['sp-adminCategoryAddDesc'] = 'Here you can add new article category.';
$txt['portalactive'] = 'Portal is active?';
$txt['showleft'] = 'Show left side blocks:';
$txt['showright'] = 'Show right side blocks:';
$txt['leftwidth'] = 'Left side blocks width:';
$txt['rightwidth'] = 'Right side blocks width:';
$txt['articleactive'] = 'Articles active?';
$txt['articleperpage'] = 'Article count per page:';
$txt['articlelength'] = 'Article character limit:';
$txt['articleavatar'] = 'Show article poster avatar:';
$txt['articleview'] = 'Article view template active:';
$txt['articleview'] = 'Article view template active:';

// Admin Columns
$txt['sp-adminColumnLabel'] = 'Label';
$txt['sp-adminColumnType'] = 'Type';
$txt['sp-adminColumnRow'] = 'Row';
$txt['sp-adminColumnState'] = 'State';
$txt['sp-adminColumnAction'] = 'Action';
$txt['sp-adminColumnPicture'] = 'Picture';
$txt['sp-adminColumnName'] = 'Name';
$txt['sp-adminColumnArticles'] = 'Articles';
$txt['sp-adminColumnPublish'] = 'Publish';
$txt['sp-adminColumnTopic'] = 'Topic';
$txt['sp-adminColumnBoard'] = 'Board';
$txt['sp-adminColumnPoster'] = 'Poster';
$txt['sp-adminColumnTime'] = 'Time';
$txt['sp-adminColumnCategory'] = 'Category';
$txt['sp-adminColumnApproved'] = 'Approved';

// Blocks
$txt['sp-blocksBlocks'] = 'Blocks';
$txt['sp-blocksCreate'] = 'Create Block';
$txt['sp-blocksActive'] = 'Active';
$txt['sp-blocksDeactive'] = 'Deactive';
$txt['sp-blocksAdd'] = 'Add Block';
$txt['sp-blocksLabel'] = 'Label';
$txt['sp-blocksParameter'] = 'Parameter';
$txt['sp-blocksContent'] = 'Content';
$txt['sp-blocksColumn'] = 'Column';
$txt['sp-blocksRow'] = 'Row';
$txt['sp-blocksActive'] = 'Active';
$txt['sp-blocksEdit'] = 'Edit Block';
$txt['sp-blocksSelectType'] = 'Select Block Type';
$txt['sp-blocksParameters'] = 'Parameter(s)';

// Articles
$txt['sp-articlesComments'] = 'Comments';
$txt['sp-articlesViews'] = 'Views';
$txt['sp-articlesPages'] = 'Pages';
$txt['sp-articlesAdd'] = 'Add Article';
$txt['sp-articlesConfirm'] = 'Are you sure?';
$txt['sp-articlesRemove'] = 'Remove Selected';
$txt['sp-articlesEdit'] = 'Edit Article';
$txt['sp-articlesApproved'] = 'Approved';

// Categories
$txt['sp-categoriesCategories'] = 'Categories';
$txt['sp-categoriesAdd'] = 'Add Category';
$txt['sp-categoriesName'] = 'Name';
$txt['sp-categoriesPicture'] = 'Picture Url';
$txt['sp-categoriesPublish'] = 'Publish on Portal';
$txt['sp-categoriesEdit'] = 'Edit Category';
$txt['sp-categoriesDelete'] = 'Delete Category';
$txt['sp-categoriesDeleteCount'] = 'There are %s article(s) in this category.';
$txt['sp-categoriesDeleteOption1'] = 'Do you want to move them to another category?';
$txt['sp-categoriesDeleteOption2'] = 'All articles will also be deleted.';
$txt['sp-categoriesMove'] = 'Move';
$txt['sp-categoriesMoveTo'] = 'Move to';

// Positions
$txt['sp-positionLeft'] = 'Left';
$txt['sp-positionMiddleTop'] = 'Middle-Top';
$txt['sp-positionMiddleBottom'] = 'Middle-Bottom';
$txt['sp-positionRight'] = 'Right';

// Placements
$txt['sp-placementBefore'] = 'Before';
$txt['sp-placementAfter'] = 'After';
$txt['sp-placementUnchanged'] = 'Unchanged';

// State
$txt['sp-stateYes'] = 'Yes';
$txt['sp-stateNo'] = 'No';

// Function Labels
$txt['sp_function_sp_userInfo_label'] = 'User Info Block';
$txt['sp_function_sp_latestMember_label'] = 'Latest Member Block';
$txt['sp_function_sp_whosOnline_label'] = 'Who\'s Online Block';
$txt['sp_function_sp_showPoll_label'] = 'Show Poll Block';
$txt['sp_function_sp_boardStats_label'] = 'Board Stats Block';
$txt['sp_function_sp_quickSearch_label'] = 'Quick Search Block';
$txt['sp_function_sp_topPoster_label'] = 'Top Poster Block';
$txt['sp_function_sp_topBoards_label'] = 'Top Boards Block';
$txt['sp_function_sp_topTopics_label'] = 'Top Topics Block';
$txt['sp_function_sp_recentPosts_label'] = 'Recent Posts Block';
$txt['sp_function_sp_recentTopics_label'] = 'Recent Topics Block';
$txt['sp_function_sp_boardNews_label'] = 'Board News Block';
$txt['sp_function_sp_news_label'] = 'News Block';
$txt['sp_function_sp_smfShop_label'] = 'SMF Shop Block';
$txt['sp_function_sp_smfArcade_label'] = 'SMF Arcade Block';
$txt['sp_function_sp_smfGallery_label'] = 'SMF Gallery Block';
$txt['sp_function_sp_bbc_label'] = 'BBC Block';
$txt['sp_function_sp_html_label'] = 'HTML Block';
$txt['sp_function_sp_php_label'] = 'PHP Block';

// Function Descriptions
$txt['sp_function_sp_latestMember_desc'] = 'Displays the latest member with his/her avatar.';
$txt['sp_function_sp_userInfo_desc'] = 'When the user is logged in this displays their information, when they are a guest it shows a login box.';
$txt['sp_function_sp_whosOnline_desc'] = 'Displays the who\'s online list.';
$txt['sp_function_sp_showPoll_desc'] = 'When user can vote, it displays the choices with the poll question. If user cannot vote, it shows the results.';
$txt['sp_function_sp_boardStats_desc'] = 'Displays some stats about the forum.';
$txt['sp_function_sp_quickSearch_desc'] = 'Displays a simple form for quick search.';
$txt['sp_function_sp_topPoster_desc'] = 'Shows the top posters with their post count and avatars.';
$txt['sp_function_sp_topBoards_desc'] = 'Displays list of boards in the order of activity.';
$txt['sp_function_sp_topTopics_desc'] = 'Lists topics according to the replies or views.';
$txt['sp_function_sp_recentPosts_desc'] = 'Shows recent posts from all over the forum.';
$txt['sp_function_sp_recentTopics_desc'] = 'Shows recent topics from all over the forum.';
$txt['sp_function_sp_boardNews_desc'] = 'Displays a number of posts selected from a definite board.';
$txt['sp_function_sp_news_desc'] = 'Show a random news line.';
$txt['sp_function_sp_smfShop_desc'] = 'Shows recent purchased items.';
$txt['sp_function_sp_smfArcade_desc'] = 'Displays the top players and the last winner.';
$txt['sp_function_sp_smfGallery_desc'] = 'Displays either the last picture added to the gallery or a random picture.';
$txt['sp_function_sp_bbc_desc'] = 'A block in which you can add bbc content.';
$txt['sp_function_sp_html_desc'] = 'A block in which you can add html content.';
$txt['sp_function_sp_php_desc'] = 'A block in which you can add php content.';

// Function Parameters
$txt['sp_function_sp_showPoll_param'] = '<b>Parameter 1:</b> The ID of the topic containing the poll you wish to show.';
$txt['sp_function_sp_topPoster_param'] = '<b>Parameter 1:</b> How many top posters to find.';
$txt['sp_function_sp_topBoards_param'] = '<b>Parameter 1:</b> How many boards to find.';
$txt['sp_function_sp_topTopics_param'] = '<b>Parameter 1:</b> The sorting type. (Enter 1 for replies, 0 for views)<br /><b>Parameter 2:</b> How many topics to find.';
$txt['sp_function_sp_recentPosts_param'] = '<b>Parameter 1:</b> How many recent topics to display.';
$txt['sp_function_sp_recentTopics_param'] = '<b>Parameter 1:</b> How many recent topics to display.';
$txt['sp_function_sp_boardNews_param'] = '<b>Parameter 1:</b> The ID of the board to pull the info from.<br /><b>Parameter 2:</b> The maximum number of items to find.<br /><b>Parameter 3:</b> The ID of a particular post to start with (otherwise the first result will be used).<br /><b>Parameter 4:</b> If specified, posts longer than this will be shortened and have "..." or a "Read More" link appended.<br /><b>Parameter 5:</b> Show avatars? (Enter 1 to activate, 0 to deactivate)';
$txt['sp_function_sp_smfArcade_param'] = '<b>Parameter 1:</b> Number of top players to get.';
$txt['sp_function_sp_smfGallery_param'] = '<b>Parameter 1:</b> Display type; enter "random" for random and enter "latest" for latest. (Enter 1 for latest, 0 for random)';
$txt['sp_function_sp_html_param'] = '<b>Content:</b> Enter the content of the block. Note that it should be HTML.';
$txt['sp_function_sp_php_param'] = '<b>Content:</b> Enter the content of the block. Note that it should be PHP.';

?>
