<?php

if (!defined('SMF'))
	die('Hacking attempt...');

/*

sportal_init()
sportal()
getArticles()
sp_userInfo()
sp_latestMember()
sp_whosOnline()
sp_showPoll()
sp_boardStats()
sp_topPoster()
sp_topBoards()
sp_topTopics()
sp_recentPosts()
sp_recentTopics()
sp_boardNews()
sp_smfShop()
sp_smfGallery()
sp_smfArcade()
sp_quickSearch()
sp_news()
sp_bbc()
sp_html()
sp_php()
sp_loadColors()

*/

function sportal_init()
{

	global $context;

	$context['page_title'] = $context['forum_name'];

}

function sportal()
{

	global $context, $txt, $db_prefix, $user_info, $sourcedir, $scripturl, $article_request, $modSettings;

	require_once($sourcedir . '/Subs-SPortal.php');

	if(!empty($_REQUEST['sa']) && $_REQUEST['sa'] == 'addarticle') {

		if(!(allowedTo('sp_add_article') || allowedTo('sp_moderate')))
			fatal_lang_error('error_sp_cannot_add_article');
			
		$context['message'] = !empty($_REQUEST['message']) ? (int) $_REQUEST['message'] : 0;
		$context['return'] = !empty($_REQUEST['return']) ? $_REQUEST['return'] : '';

		if($context['message'] == 0)
			fatal_lang_error('error_sp_no_message_id');

		$request = db_query("
			SELECT ID_MESSAGE
			FROM {$db_prefix}sp_articles
			WHERE ID_MESSAGE = '$context[message]'
			LIMIT 1", __FILE__, __LINE__);
		list ($exists) = mysql_fetch_row($request);
		mysql_free_result($request);		

		if($exists)
			fatal_lang_error('error_sp_article_exists');
			
		$context['list_categories'] = getCategoryInfo();

		if(empty($context['list_categories']))
			fatal_lang_error('error_sp_no_category', false);
			
		$context['sub_template'] = 'article_add';
	}
	elseif(!empty($_REQUEST['sa']) && $_REQUEST['sa'] == 'createarticle') {
		
		if(!(allowedTo('sp_add_article') || allowedTo('sp_moderate')))
			fatal_lang_error('error_sp_cannot_add_article');

		$articleOptions = array(
			'ID_CATEGORY' => !empty($_POST['category']) ? (int) $_POST['category'] : 0,
			'ID_MESSAGE' => !empty($_POST['message']) ? (int) $_POST['message'] : 0,
			'approved' => allowedTo('sp_auto_article_approval') || allowedTo('sp_moderate') ? 1 : 0,
		);
	
		createArticle($articleOptions);

		redirectexit('topic=' . $_POST['return']);
	}
			
	loadLanguage('SPortal');
	loadLanguage('Stats');
	loadTemplate('SPortal');

	$context['sides'] = array(
		'left' => array(
			'id' => '1',
			'label' => $txt['sp-positionLeft'],
		),
		'middle_top' => array(
			'id' => '2',
			'label' => $txt['sp-positionMiddleTop'],
		),
		'middle_bottom' => array(
			'id' => '3',
			'label' => $txt['sp-positionMiddleBottom'],
		),
		'right' => array(
			'id' => '4',
			'label' => $txt['sp-positionRight'],
		),
	);

	foreach($context['sides'] as $side) {
		$context['blocks'][$side['label']] = getBlockInfo($side['id'], null, 1);
	}

	if(!empty($modSettings['articleactive'])) {

		$request = db_query("
			SELECT COUNT(*)
			FROM {$db_prefix}sp_articles as a
				LEFT JOIN {$db_prefix}sp_categories AS c ON (c.ID_CATEGORY = a.ID_CATEGORY)
				LEFT JOIN {$db_prefix}messages AS m ON (m.ID_MSG = a.ID_MESSAGE)
				LEFT JOIN {$db_prefix}boards AS b ON (b.ID_BOARD = m.ID_BOARD)
			WHERE $user_info[query_see_board]
				AND approved = 1
				AND publish = 1", __FILE__, __LINE__);
		list ($totalArticles) = mysql_fetch_row($request);
		mysql_free_result($request);

		$context['page_index'] = constructPageIndex($scripturl . '?sa=articles', $_REQUEST['start'], $totalArticles, $modSettings['articleperpage']);
		$context['start'] = $_REQUEST['start'];

		$article_request = db_query("
			SELECT a.ID_ARTICLE, a.ID_CATEGORY, a.ID_MESSAGE, a.approved, c.name as cname, c.picture, m.ID_MEMBER,
				IFNULL(mem.realName, m.posterName) AS posterName, m.icon, m.subject, m.body, m.posterTime,
				m.smileysEnabled, t.ID_TOPIC, t.numReplies, t.numViews, t.locked, b.ID_BOARD, b.name as bname,
				mem.avatar, at.ID_ATTACH, at.attachmentType, at.filename
			FROM {$db_prefix}sp_articles AS a
				LEFT JOIN {$db_prefix}sp_categories AS c ON (c.ID_CATEGORY = a.ID_CATEGORY)
				LEFT JOIN {$db_prefix}messages AS m ON (m.ID_MSG = a.ID_MESSAGE)
				LEFT JOIN {$db_prefix}topics AS t ON (t.ID_FIRST_MSG = a.ID_MESSAGE)
				LEFT JOIN {$db_prefix}boards AS b ON (b.ID_BOARD = m.ID_BOARD)
				LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER)
				LEFT JOIN {$db_prefix}attachments AS at ON (at.ID_MEMBER = m.ID_MEMBER)
			WHERE $user_info[query_see_board]
				AND approved = 1
				AND publish = 1
			ORDER BY a.ID_MESSAGE DESC
			LIMIT $context[start], $modSettings[articleperpage]", __FILE__, __LINE__);

		$context['get_articles'] = 'getArticles';
	}
}

function getArticles($reset = false)
{
	global $scripturl, $article_request, $txt, $context, $settings, $func, $modSettings;

	if ($article_request == false)
		return false;

	if (!($row = mysql_fetch_assoc($article_request)))
		return false;

	$stable_icons = array('xx', 'thumbup', 'thumbdown', 'exclamation', 'question', 'lamp', 'smiley', 'angry', 'cheesy', 'grin', 'sad', 'wink', 'moved', 'recycled', 'wireless');
	$icon_sources = array();
	foreach ($stable_icons as $icon)
		$icon_sources[$icon] = 'images_url';

	if(!empty($modSettings['articlelength']))
		$length = $modSettings['articlelength'];
	else
		$length = 300;
	
	if (!empty($length) && $func['strlen']($row['body']) > $length)
	{
		$row['body'] = $func['substr']($row['body'], 0, $length);

		$cutoff = max(strrpos($row['body'], ' '), strrpos($row['body'], '<'));

		if ($cutoff !== false)
			$row['body'] = $func['substr']($row['body'], 0, $cutoff);
		$row['body'] .= '...';
	}

	$row['body'] = parse_bbc($row['body'], $row['smileysEnabled'], $row['ID_MESSAGE']);

	if (empty($modSettings['messageIconChecks_disable']) && !isset($icon_sources[$row['icon']]))
		$icon_sources[$row['icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['icon'] . '.gif') ? 'images_url' : 'default_images_url';

	censorText($row['subject']);
	censorText($row['body']);
		
	if (stristr($row['avatar'], 'http://') && !empty($modSettings['avatar_check_size']))
	{
		$sizes = url_image_size($row['avatar']);

		if ($modSettings['avatar_action_too_large'] == 'option_refuse' && is_array($sizes) && (($sizes[0] > $modSettings['avatar_max_width_external'] && !empty($modSettings['avatar_max_width_external'])) || ($sizes[1] > $modSettings['avatar_max_height_external'] && !empty($modSettings['avatar_max_height_external']))))
		{
			$row['avatar'] = '';
			updateMemberData($row['ID_MEMBER'], array('avatar' => '\'\''));
		}
	}

	$output = array(
		'article' => array(
			'id' => $row['ID_ARTICLE'],
			'comment_href' => !empty($row['locked']) ? '' : $scripturl . '?action=post;topic=' . $row['ID_TOPIC'] . '.' . $row['numReplies'] . ';num_replies=' . $row['numReplies'],
			'comment_link' => !empty($row['locked']) ? '' : '<a href="' . $scripturl . '?action=post;topic=' . $row['ID_TOPIC'] . '.' . $row['numReplies'] . ';num_replies=' . $row['numReplies'] . '">' . $txt['smf_news_3'] . '</a>',
			'new_comment' => !empty($row['locked']) ? '' : '<a href="' . $scripturl . '?action=post;topic=' . $row['ID_TOPIC'] . '.' . $row['numReplies'] . '">' . $txt['smf_news_3'] . '</a>',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0' . (!empty($modSettings['articleview']) ? ';view=article' : '') . '">' . $row['numReplies'] . ' ' . ($row['numReplies'] == 1 ? $txt['smf_news_1'] : $txt['smf_news_2']) . '</a>',
			'approved' => $row['approved'],
		),
		'category' => array(
			'id' => $row['ID_CATEGORY'],
			'name' => $row['cname'],
			'picture' => array (
				'href' => $row['picture'],
				'image' => '<img src="' . $row['picture'] . '" alt="' . $row['cname'] . '" width="75" />',
			),
		),
		'message' => array(
			'id' => $row['ID_MESSAGE'],
			'icon' => '<img src="' . $settings[$icon_sources[$row['icon']]] . '/post/' . $row['icon'] . '.gif" align="middle" alt="' . $row['icon'] . '" border="0" />',
			'subject' => $row['subject'],
			'body' => $row['body'],
			'timeyear' => timeformat($row['posterTime'], '%d %b %y'),
			'timeday' => timeformat($row['posterTime'], '%H:%M:%S'),
		),
		'poster' => array(
			'id' => $row['ID_MEMBER'],
			'name' => $row['posterName'],
			'href' => !empty($row['ID_MEMBER']) ? $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] : '',
			'link' => !empty($row['ID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['posterName'] . '</a>' : $row['posterName'],
			'avatar' => array(
				'name' => $row['avatar'],
				'image' => $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? '<img src="' . (empty($row['attachmentType']) ? $scripturl . '?action=dlattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) . '" alt="" class="avatar" border="0" />' : '') : (stristr($row['avatar'], 'http://') ? '<img src="' . $row['avatar'] . '" alt="" class="avatar" border="0" />' : '<img src="' . $modSettings['avatar_url'] . '/' . htmlspecialchars($row['avatar']) . '" alt="" class="avatar" border="0" />'),
				'href' => $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? (empty($row['attachmentType']) ? $scripturl . '?action=dlattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) : '') : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar']),
				'url' => $row['avatar'] == '' ? '' : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar']),
			),
		),
		'topic' => array(
			'id' => $row['ID_TOPIC'],
			'replies' => $row['numReplies'],
			'views' => $row['numViews'],
			'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0' . (!empty($modSettings['articleview']) ? ';view=article' : '') . '">' . $row['subject'] . '</a>',
			'locked' => !empty($row['locked']),
		),
		'board' => array(
			'id' => $row['ID_BOARD'],
			'name' => $row['bname'],
			'link' => '<a href="' . $scripturl . '?board=' . $row['ID_BOARD'] . '.0">' . $row['bname'] . '</a>',
		),
	);

	return $output;
}

function sp_userInfo()
{
	global $context, $txt, $scripturl, $settings, $memberContext, $modSettings, $member_id, $sc;

	if($context['user']['is_logged']) {
		$member_id = $context['user']['id'];
		loadMemberData($member_id);
		loadMemberContext($member_id);

		$memberContext[$member_id]['karma']['total'] = $memberContext[$member_id]['karma']['good'] - $memberContext[$member_id]['karma']['bad'];
	}
			echo '<div align="center">';

			if ($context['user']['is_guest'])
				echo '<form action="', $scripturl, '?action=login2" method="post" accept-charset="', $context['character_set'], '">
			<table border="0" cellspacing="1" cellpadding="0" class="ssi_table">
				<tr>
					<td align="right"><label for="user">', $txt[35], ':</label>&nbsp;</td>
					<td><input type="text" id="user" name="user" size="9" value="', !empty($user_info['username']) ? $user_info['username'] : '', '" /></td>
				</tr><tr>
					<td align="right"><label for="passwrd">', $txt[36], ':</label>&nbsp;</td>
					<td><input type="password" name="passwrd" id="passwrd" size="9" /></td>
				</tr><tr>
					<td><input type="hidden" name="cookielength" value="-1" /></td>
					<td><input type="submit" value="', $txt[34], '" /></td>
				</tr>
			</table>
		</form>', $txt['welcome_guest'];

			else
			{
				echo $txt['hello_member'], ' <b>', $context['user']['name'], '</b><br /><br />';

				if (!empty($context['user']['avatar']))
					echo $context['user']['avatar']['image'], '<br /><br />';

					if (!empty($memberContext[$member_id]['group']))
						echo $memberContext[$member_id]['group'];
					else
						echo $memberContext[$member_id]['post_group'];

					echo '<br />', $memberContext[$member_id]['group_stars'], '<br /><br /></div>
						<img src="' . $settings['images_url'] . '/dot.gif" alt="Dot" /> ', $txt['sp-userpost'], ': ',$memberContext[$member_id]['posts'],'<br />
						<img src="' . $settings['images_url'] . '/dot.gif" alt="Dot" /> ', $txt['sp-userkarma'], ': ',$memberContext[$member_id]['karma']['total'],'<br />';
			}

			if(allowedTo('pm_read'))
			echo '
			<img src="' . $settings['images_url'] . '/dot.gif" alt="Dot" /> ', $txt['sp-usertmessage'], ': <a href="' . $scripturl . '?action=pm">' . $context['user']['messages'], '</a><br />
			<img src="' . $settings['images_url'] . '/dot.gif" alt="Dot" /> ', $txt['sp-usernmessage'], ': ' . $context['user']['unread_messages'], '<br /><br />';

			if (!$context['user']['is_guest'])
			echo '<div align="center"><img src="' . $settings['images_url'] . '/arrow.gif" alt="Arrow" /> <a href="'.$scripturl.'?action=profile">', $txt['sp-userprofile'], '</a>&nbsp;&nbsp;&nbsp;<img src="' . $settings['images_url'] . '/arrow.gif" alt="Arrow" /> <a href="', $scripturl, '?action=logout;sesc=', $sc, '">', $txt['sp-userlogout'], '</a></div>';

}

function sp_latestMember()
{
	global $db_prefix, $txt, $scripturl, $context, $memberContext, $latest_member_id;

	$latest_member_id = $context['common_stats']['latest_member']['id'];
	loadMemberData($latest_member_id);
	loadMemberContext($latest_member_id);

	echo '<table align="center">';
		if (!empty($memberContext[$latest_member_id]['avatar']['href']))
	echo '
	<tr>
		<td align="center"><img src="'.$memberContext[$latest_member_id]['avatar']['href'].'" alt="" width="60" /></td>
	</tr>';
	echo '
	<tr>
		<td align="center">', $memberContext[$latest_member_id]['link'], '</td>
	</tr>
	</table>';
}


function sp_whosOnline()
{
	global $scripturl, $db_prefix, $user_info, $txt, $settings, $online;

	$result = db_query("
		SELECT
			lo.ID_MEMBER, lo.logTime, mem.realName, mem.memberName, mem.showOnline,
			mg.onlineColor, mg.ID_GROUP
		FROM {$db_prefix}log_online AS lo
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = lo.ID_MEMBER)
			LEFT JOIN {$db_prefix}membergroups AS mg ON (mg.ID_GROUP = IF(mem.ID_GROUP = 0, mem.ID_POST_GROUP, mem.ID_GROUP))", __FILE__, __LINE__);

	$online['users'] = array();
	$online['guests'] = 0;
	$online['hidden'] = 0;
	$online['buddies'] = 0;
	$show_buddies = !empty($user_info['buddies']);

	while ($row = mysql_fetch_assoc($result))
	{
		if (!isset($row['realName']))
			$online['guests']++;
		elseif (!empty($row['showOnline']) || allowedTo('moderate_forum'))
		{
			// Some basic color coding...
			if (!empty($row['onlineColor']))
				$link = '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '" style="color: ' . $row['onlineColor'] . ';">' . $row['realName'] . '</a>';
			else
				$link = '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['realName'] . '</a>';

			// Bold any buddies.
			if ($show_buddies && in_array($row['ID_MEMBER'], $user_info['buddies']))
			{
				$online['buddies']++;
				$link = '<b>' . $link . '</b>';
			}

			$online['users'][$row['logTime'] . $row['memberName']] = array(
				'id' => $row['ID_MEMBER'],
				'username' => $row['memberName'],
				'name' => $row['realName'],
				'group' => $row['ID_GROUP'],
				'href' => $scripturl . '?action=profile;u=' . $row['ID_MEMBER'],
				'link' => $link,
				'hidden' => empty($row['showOnline']),
				'is_last' => false,
			);
		}
		else
			$online['hidden']++;
	}
	mysql_free_result($result);

	if (!empty($online['users']))
	{
		krsort($online['users']);
		$userlist = array_keys($online['users']);
		$online['users'][$userlist[count($userlist) - 1]]['is_last'] = true;
	}
	$online['num_users'] = count($online['users']) + $online['hidden'];
	$online['total_users'] = $online['num_users'] + $online['guests'];

		echo '<table>
		<tr>
			<td><img src="' . $settings['images_url'] . '/dot.gif" alt="Dot" /></td>
			<td>', $txt['sp-onlineguest'], '</td>
			<td>:</td>
			<td>', $online['guests'],'</td>
		</tr>
		<tr>
			<td><img src="' . $settings['images_url'] . '/dot.gif" alt="Dot" /></td>
			<td>', $txt['sp-onlineuser'], '</td>
			<td>:</td>
			<td>', $online['num_users'],'</td>
		</tr>
		<tr>
			<td><img src="' . $settings['images_url'] . '/dot.gif" alt="Dot" /></td>
			<td>', $txt['sp-onlinehuser'], '</td>
			<td>:</td>
			<td>', $online['hidden'],'</td>
		</tr>
		<tr>
			<td><img src="' . $settings['images_url'] . '/dot.gif" alt="Dot" /></td>
			<td>', $txt['sp-onlinetuser'], '</td>
			<td>:</td>
			<td>', $online['total_users'],'</td>
		</tr>';
				if(!empty($online['users']))
				echo '	<tr>
			<td><img src="' . $settings['images_url'] . '/dot.gif" alt="Dot" />
			</td><td>', $txt['sp-onlineouser'], '</td>
			<td>:</td>
			<td>&nbsp;</td>
		</tr>';

		foreach ($online['users'] as $user)
			echo '<tr>
					<td colspan="4" style="padding-left: 15px;"><img src="' . $settings['images_url'] . '/useron.gif" alt="user" /> ',$user['hidden'] ? '<i>' . $user['link'] . '</i>' : $user['link'],'</td>
				</tr>';
		echo '</table>';
}

function sp_showPoll($topic = null)
{
	global $context, $db_prefix, $txt, $ID_MEMBER, $settings, $boardurl, $sc, $user_info, $modSettings, $poll, $total, $scripturl;

	$boardsAllowed = boardsAllowedTo('poll_view');

	if (empty($boardsAllowed))
		return array();

	if ($topic === null && isset($_REQUEST['ssi_topic']))
		$topic = (int) $_REQUEST['ssi_topic'];
	else
		$topic = (int) $topic;

	$request = db_query("
		SELECT
			p.ID_POLL, p.question, p.votingLocked, p.hideResults, p.expireTime, p.maxVotes, b.ID_BOARD
		FROM ({$db_prefix}topics AS t, {$db_prefix}polls AS p, {$db_prefix}boards AS b)
		WHERE p.ID_POLL = t.ID_POLL
			AND t.ID_TOPIC = $topic
			AND b.ID_BOARD = t.ID_BOARD
			AND $user_info[query_see_board]" . (!in_array(0, $boardsAllowed) ? "
			AND b.ID_BOARD IN (" . implode(', ', $boardsAllowed) . ")" : '') . "
		LIMIT 1", __FILE__, __LINE__);

	// Either this topic has no poll, or the user cannot view it.
	if (mysql_num_rows($request) == 0) {
		echo 'Topic ID entered doesn\'t contain a poll.';
		return array();
	}

	$row = mysql_fetch_assoc($request);
	mysql_free_result($request);

	// Check if they can vote.
	if (!empty($row['expireTime']) && $row['expireTime'] < time())
		$allow_vote = false;
	elseif ($user_info['is_guest'] || !empty($row['votingLocked']) || !allowedTo('poll_vote', array($row['ID_BOARD'])))
		$allow_vote = false;
	else
	{
		$request = db_query("
			SELECT ID_MEMBER
			FROM {$db_prefix}log_polls
			WHERE ID_POLL = $row[ID_POLL]
				AND ID_MEMBER = $ID_MEMBER
			LIMIT 1", __FILE__, __LINE__);
		$allow_vote = mysql_num_rows($request) == 0;
		mysql_free_result($request);
	}

	$request = db_query("
		SELECT COUNT(DISTINCT ID_MEMBER)
		FROM {$db_prefix}log_polls
		WHERE ID_POLL = $row[ID_POLL]", __FILE__, __LINE__);
	list ($total) = mysql_fetch_row($request);
	mysql_free_result($request);

	$request = db_query("
		SELECT ID_CHOICE, label, votes
		FROM {$db_prefix}poll_choices
		WHERE ID_POLL = $row[ID_POLL]", __FILE__, __LINE__);
	$options = array();
	$total_votes = 0;
	while ($rowChoice = mysql_fetch_assoc($request))
	{
		censorText($rowChoice['label']);

		$options[$rowChoice['ID_CHOICE']] = array($rowChoice['label'], $rowChoice['votes']);
		$total_votes += $rowChoice['votes'];
	}
	mysql_free_result($request);

	$poll = array(
		'id' => $row['ID_POLL'],
		'image' => empty($pollinfo['votingLocked']) ? 'poll' : 'locked_poll',
		'question' => $row['question'],
		'total_votes' => $total,
		'is_locked' => !empty($pollinfo['votingLocked']),
		'allow_vote' => $allow_vote,
		'topic' => $topic
	);

	// Calculate the percentages and bar lengths...
	$divisor = $total_votes == 0 ? 1 : $total_votes;
	foreach ($options as $i => $option)
	{
		$bar = floor(($option[1] * 100) / $divisor);
		$barWide = $bar == 0 ? 1 : floor(($bar * 5) / 4);
		$poll['options'][$i] = array(
			'id' => 'options-' . $i,
			'percent' => $bar,
			'votes' => $option[1],
			'bar' => '<span style="white-space: nowrap;"><img src="' . $settings['images_url'] . '/poll_left.gif" alt="" /><img src="' . $settings['images_url'] . '/poll_middle.gif" width="' . $barWide . '" height="12" alt="-" /><img src="' . $settings['images_url'] . '/poll_right.gif" alt="" /></span>',
			'option' => parse_bbc($option[0]),
			'vote_button' => '<input type="' . ($row['maxVotes'] > 1 ? 'checkbox' : 'radio') . '" name="options[]" id="options-' . $i . '" value="' . $i . '" class="check" />'
		);
	}

	$poll['allowed_warning'] = $row['maxVotes'] > 1 ? sprintf($txt['poll_options6'], $row['maxVotes']) : '';

	if ($poll['allow_vote'])
	{
		echo '
			<form action="', $scripturl, '?action=vote;topic=', $poll['topic'], '.0;poll=', $poll['id'], '" method="post" accept-charset="', $context['character_set'], '" style="margin: 0px;">
				<input type="hidden" name="poll" value="', $poll['id'], '" />
				<table border="0" cellspacing="1" cellpadding="0" class="ssi_table">
					<tr>
						<td><b>', $poll['question'], '</b></td>
					</tr>
					<tr>
						<td>', $poll['allowed_warning'], '</td>
					</tr>';
		foreach ($poll['options'] as $option)
			echo '
					<tr>
						<td><label for="', $option['id'], '">', $option['vote_button'], ' ', $option['option'], '</label></td>
					</tr>';
		echo '
					<tr>
						<td><input type="submit" value="', $txt['smf23'], '" /></td>
					</tr>
				</table>
				<input type="hidden" name="sc" value="', $sc, '" />
			</form>';
	}
	else
	{
		echo '
				<table border="0" cellspacing="1" cellpadding="0" class="ssi_table">
					<tr>
						<td colspan="2"><b>', $poll['question'], '</b></td>
					</tr>';
		foreach ($poll['options'] as $option)
			echo '
					<tr>
						<td align="right" valign="top">', $option['option'], ' </td>
						<td align="left">| ', $option['votes'], ' (', $option['percent'], '%)</td>
					</tr>
					<tr>
						<td align="left" colspan="2">', $option['bar'], '</td>
					</tr>';
		echo '
					<tr>
						<td colspan="2"><b>', $txt['smf24'], ': ', $poll['total_votes'], '</b></td>
					</tr>
				</table>';
	}
}

function sp_boardStats()
{
	global $db_prefix, $txt, $scripturl, $modSettings, $settings, $totals;

	$totals = array(
		'members' => $modSettings['totalMembers'],
		'posts' => $modSettings['totalMessages'],
		'topics' => $modSettings['totalTopics']
	);

	$result = db_query("
		SELECT COUNT(*)
		FROM {$db_prefix}boards", __FILE__, __LINE__);
	list ($totals['boards']) = mysql_fetch_row($result);
	mysql_free_result($result);

	$result = db_query("
		SELECT COUNT(*)
		FROM {$db_prefix}categories", __FILE__, __LINE__);
	list ($totals['categories']) = mysql_fetch_row($result);
	mysql_free_result($result);

				echo '<table>
			<tr>
				<td><img src="' . $settings['images_url'] . '/dot.gif" alt="Dot" /></td>
				<td>', $txt['sp-statmember'], '</td>
				<td>:</td>
				<td><a href="', $scripturl . '?action=mlist">', $totals['members'], '</a></td>
			</tr>
			<tr>
				<td><img src="' . $settings['images_url'] . '/dot.gif" alt="Dot" /></td>
				<td>', $txt['sp-statpost'], '</td>
				<td>:</td>
				<td>', $totals['posts'], '</td>
			</tr>
			<tr>
				<td><img src="' . $settings['images_url'] . '/dot.gif" alt="Dot" /></td>
				<td>', $txt['sp-stattopic'], '</td>
				<td>:</td>
				<td>', $totals['topics'], '</td>
			</tr>
			<tr>
				<td><img src="' . $settings['images_url'] . '/dot.gif" alt="Dot" /></td>
				<td>', $txt['sp-statcategory'], '</td>
				<td>:</td>
				<td>', $totals['categories'], '</td>
			</tr>
			<tr>
				<td><img src="' . $settings['images_url'] . '/dot.gif" alt="Dot" /></td>
				<td>', $txt['sp-statboard'], '</td>
				<td>:</td>
				<td>', $totals['boards'], '</td>
			</tr>
		</table>';
}

function sportal_vital()
{
	$text = 'S*i-m+p*l-e+P*o-r+t*a-l+ *2-.+0* *&-c+o*p-y+;* -<+a* -h+r*e-f+=*"-h+t*t-p+:*/-/+w*w-w+.*s-a+m*a-n+y*o-l+u*f-a+n*l-a*r-i.+c*o-m+/*"- +t*a-r+g*e-t+=*"-_+b*l-a+n*k-"+>*[-S+i*N-a+N*]-<+/*a->+';
	$trans = array("+" => "", "-" => "", "*" => "");
	echo '<br />' . strtr($text, $trans);
}

function sp_topPoster($topNumber = 5)
{
	global $db_prefix, $scripturl, $memberContext, $txt, $settings, $modSettings, $top_posters, $top_poster_id, $list_no;

	if ($topNumber === null)
		$topNumber = isset($_GET['limit']) ? (int) $_GET['limit'] : 5;

	$list_no=1;

	// Find the latest poster.
	$request = db_query("
		SELECT m.ID_MEMBER, m.realName, m.posts, m.avatar, a.ID_ATTACH, a.attachmentType, a.filename
		FROM ({$db_prefix}members as m)
			LEFT JOIN {$db_prefix}attachments AS a ON (a.ID_MEMBER = m.ID_MEMBER)
		ORDER BY posts DESC
		LIMIT $topNumber", __FILE__, __LINE__);
	$top_posters = array();
	$colorids = array();
	while ($row = mysql_fetch_assoc($request)) {
		if (stristr($row['avatar'], 'http://') && !empty($modSettings['avatar_check_size']))
		{
			$sizes = url_image_size($row['avatar']);

			// Does your avatar still fit the maximum size?
			if ($modSettings['avatar_action_too_large'] == 'option_refuse' && is_array($sizes) && (($sizes[0] > $modSettings['avatar_max_width_external'] && !empty($modSettings['avatar_max_width_external'])) || ($sizes[1] > $modSettings['avatar_max_height_external'] && !empty($modSettings['avatar_max_height_external']))))
			{
				// Fix it permanently!
				$row['avatar'] = '';
				updateMemberData($row['ID_MEMBER'], array('avatar' => '\'\''));
			}
		}

		//Collect the ids
		$colorids[$row['ID_MEMBER']] = $row['ID_MEMBER'];

		$top_posters[] = array(
			'list' => $list_no++,
			'id' => $row['ID_MEMBER'],
			'name' => $row['realName'],
			'href' => $scripturl . '?action=profile;u=' . $row['ID_MEMBER'],
			'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['realName'] . '</a>',
			'posts' => $row['posts'],
			'avatar' => array(
				'name' => $row['avatar'],
				'image' => $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? '<img src="' . (empty($row['attachmentType']) ? $scripturl . '?action=dlattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) . '" alt="" class="avatar" border="0" />' : '') : (stristr($row['avatar'], 'http://') ? '<img src="' . $row['avatar'] . '" alt="" class="avatar" border="0" />' : '<img src="' . $modSettings['avatar_url'] . '/' . htmlspecialchars($row['avatar']) . '" alt="" class="avatar" border="0" />'),
				'href' => $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? (empty($row['attachmentType']) ? $scripturl . '?action=dlattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) : '') : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar']),
				'url' => $row['avatar'] == '' ? '' : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar']),
			)
		);
	}
	mysql_free_result($request);

	//Add Colors to the link :)
	if(!empty($colorids)) {
		global $color_profile;
		sp_loadColors($colorids);
		foreach($top_posters as $k => $p) {
			if(!empty($color_profile[$p['id']]))
				$profile = $color_profile[$p['id']];
			if(!empty($profile)) {
				$top_posters[$k]['link'] = $profile['link'];
			}
		}
	}
		echo '<table>';
		foreach ($top_posters as $member)
		{
		if (!empty($member['avatar']['href']))
		echo '				<tr>
								<td>' . $member['list'] . '-</td>
								<td><img src="' . $member['avatar']['href'] . '" alt="" width="35" /></td><td>&nbsp;</td>
								<td>' . $member['link'] . '<br />' . $member['posts'] . $txt['sp-tposterpost'] . '</td>
							</tr>';
		else
		echo '				<tr>
								<td>' . $member['list'] . '-</td>
								<td>&nbsp;</td><td>&nbsp;</td>
								<td>' . $member['link'] . '<br />' . $member['posts'] . $txt['sp-tposterpost'] . '</td>
							</tr>';
		}
		echo '</table>';

}

function sp_topBoards($num_top = 10)
{
	global $context, $settings, $db_prefix, $txt, $scripturl, $ID_MEMBER, $user_info, $modSettings, $boards;

	if ($num_top === null)
		$num_top = isset($_GET['limit']) ? (int) $_GET['limit'] : 10;

	// Find boards with lots of posts.
	$request = db_query("
		SELECT
			b.name, b.numPosts, b.ID_BOARD
		FROM {$db_prefix}boards AS b
		WHERE $user_info[query_see_board]" . (!empty($modSettings['recycle_enable']) && $modSettings['recycle_board'] > 0 ? "
			AND b.ID_BOARD != " . (int) $modSettings['recycle_board'] : '') . "
		ORDER BY b.numPosts DESC
		LIMIT $num_top", __FILE__, __LINE__);
	$boards = array();
	while ($row = mysql_fetch_assoc($request))
		$boards[] = array(
			'id' => $row['ID_BOARD'],
			'num_posts' => $row['numPosts'],
			'name' => $row['name'],
			'href' => $scripturl . '?board=' . $row['ID_BOARD'] . '.0',
			'link' => '<a href="' . $scripturl . '?board=' . $row['ID_BOARD'] . '.0">' . $row['name'] . '</a>'
		);
	mysql_free_result($request);

	// If we have nothing to output, just jump out.
	if (empty($boards))
		return $boards;
		echo '
		<table class="ssi_table">
			<tr>
				<th align="left">', $txt['sp-tboardname'], '</th>
				<th align="left">', $txt['sp-tboardpost'], '</th>
			</tr>';
		foreach ($boards as $board)
		echo '
			<tr>
				<td>', $board['link'], '</td>
				<td align="right">', $board['num_posts'], '</td>
			</tr>';
		echo '
		</table>';

}

function sp_topTopics($type = 0, $num_topics = 10)
{
	global $db_prefix, $txt, $scripturl, $ID_MEMBER, $user_info, $modSettings, $topics;

	if ($num_topics === null)
		$num_topics = isset($_GET['limit']) ? (int) $_GET['limit'] : 10;

	if ($modSettings['totalMessages'] > 100000)
	{
		$request = db_query("
			SELECT ID_TOPIC
			FROM {$db_prefix}topics
			WHERE num" . ($type != 0 ? 'Views' : 'Replies') . " != 0
			ORDER BY num" . ($type != 0 ? 'Views' : 'Replies') . " DESC
			LIMIT 100", __FILE__, __LINE__);
		$topic_ids = array();
		while ($row = mysql_fetch_assoc($request))
			$topic_ids[] = $row['ID_TOPIC'];
		mysql_free_result($request);
	}
	else
		$topic_ids = array();

	$request = db_query("
		SELECT m.subject, m.ID_TOPIC, t.numViews, t.numReplies
		FROM ({$db_prefix}topics AS t, {$db_prefix}messages AS m, {$db_prefix}boards AS b)
		WHERE m.ID_MSG = t.ID_FIRST_MSG
			AND t.ID_BOARD = b.ID_BOARD" . (!empty($topic_ids) ? "
			AND t.ID_TOPIC IN (" . implode(', ', $topic_ids) . ")" : '') . "
			AND $user_info[query_see_board]" . (!empty($modSettings['recycle_enable']) && $modSettings['recycle_board'] > 0 ? "
			AND b.ID_BOARD != $modSettings[recycle_board]" : '') . "
		ORDER BY t.num" . ($type != 0 ? 'Views' : 'Replies') . " DESC
		LIMIT $num_topics", __FILE__, __LINE__);
	$topics = array();
	while ($row = mysql_fetch_assoc($request))
	{
		censorText($row['subject']);

		$topics[] = array(
			'id' => $row['ID_TOPIC'],
			'subject' => $row['subject'],
			'num_replies' => $row['numReplies'],
			'num_views' => $row['numViews'],
			'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0">' . $row['subject'] . '</a>',
		);
	}
	mysql_free_result($request);

	if (empty($topics))
		return $topics;

		echo '
		<table class="ssi_table">
			<tr>
				<th align="left">', $txt['sp-ttopicname'], '</th>
				<th align="left">', $type ? $txt[301] : $txt[110], '</th>
			</tr>';
		foreach ($topics as $topic)
		echo '
			<tr>
				<td align="left">
					', $topic['link'], '
				</td>
				<td align="right">', $type ? $topic['num_views'] : $topic['num_replies'] , '</td>
			</tr>';
		echo '
		</table>';

}

function sp_recentPosts($num_recent = 8)
{
	global $context, $settings, $scripturl, $txt, $db_prefix, $ID_MEMBER;
	global $user_info, $modSettings, $func, $posts;

	$exclude_boards = null;

	if ($num_recent === null)
		$num_recent = isset($_GET['limit']) ? (int) $_GET['limit'] : 1;

	if ($exclude_boards === null && !empty($modSettings['recycle_enable']) && $modSettings['recycle_board'] > 0)
		$exclude_boards = array($modSettings['recycle_board']);
	else
		$exclude_boards = empty($exclude_boards) ? array() : $exclude_boards;

	// Load the message icons - the usual suspects.
	$stable_icons = array('xx', 'thumbup', 'thumbdown', 'exclamation', 'question', 'lamp', 'smiley', 'angry', 'cheesy', 'grin', 'sad', 'wink', 'moved', 'recycled', 'wireless');
	$icon_sources = array();
	foreach ($stable_icons as $icon)
		$icon_sources[$icon] = 'images_url';

	// Find all the posts.  Newer ones will have higher IDs.
	$request = db_query("
		SELECT
			m.posterTime, m.subject, m.ID_TOPIC, m.ID_MEMBER, m.ID_MSG, m.ID_BOARD, b.name AS bName,
			IFNULL(mem.realName, m.posterName) AS posterName, " . ($user_info['is_guest'] ? '1 AS isRead, 0 AS new_from' : '
			IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, 0)) >= m.ID_MSG_MODIFIED AS isRead,
			IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, -1)) + 1 AS new_from') . ", LEFT(m.body, 384) AS body, m.smileysEnabled, m.icon
		FROM ({$db_prefix}messages AS m, {$db_prefix}boards AS b)
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER)" . (!$user_info['is_guest'] ? "
			LEFT JOIN {$db_prefix}log_topics AS lt ON (lt.ID_TOPIC = m.ID_TOPIC AND lt.ID_MEMBER = $ID_MEMBER)
			LEFT JOIN {$db_prefix}log_mark_read AS lmr ON (lmr.ID_BOARD = m.ID_BOARD AND lmr.ID_MEMBER = $ID_MEMBER)" : '') . "
		WHERE m.ID_MSG >= " . ($modSettings['maxMsgID'] - 25 * min($num_recent, 5)) . "
			AND b.ID_BOARD = m.ID_BOARD" . (empty($exclude_boards) ? '' : "
			AND b.ID_BOARD NOT IN (" . implode(', ', $exclude_boards) . ")") . "
			AND $user_info[query_see_board]
		ORDER BY m.ID_MSG DESC
		LIMIT $num_recent", __FILE__, __LINE__);
	$posts = array();
	$colorids = array();
	while ($row = mysql_fetch_assoc($request))
	{
		$row['body'] = strip_tags(strtr(parse_bbc($row['body'], $row['smileysEnabled'], $row['ID_MSG']), array('<br />' => '&#10;')));
		if ($func['strlen']($row['body']) > 128)
			$row['body'] = $func['substr']($row['body'], 0, 128) . '...';

		// Censor it!
		censorText($row['subject']);
		censorText($row['body']);
		
		//Collect the color ids :)
		$colorids[$row['ID_MEMBER']] = $row['ID_MEMBER'];

		// Build the array.
		$posts[] = array(
			'board' => array(
				'id' => $row['ID_BOARD'],
				'name' => $row['bName'],
				'href' => $scripturl . '?board=' . $row['ID_BOARD'] . '.0',
				'link' => '<a href="' . $scripturl . '?board=' . $row['ID_BOARD'] . '.0">' . $row['bName'] . '</a>'
			),
			'topic' => $row['ID_TOPIC'],
			'poster' => array(
				'id' => $row['ID_MEMBER'],
				'name' => $row['posterName'],
				'href' => empty($row['ID_MEMBER']) ? '' : $scripturl . '?action=profile;u=' . $row['ID_MEMBER'],
				'link' => empty($row['ID_MEMBER']) ? $row['posterName'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['posterName'] . '</a>'
			),
			'subject' => $row['subject'],
			'short_subject' => shorten_subject($row['subject'], 25),
			'preview' => $row['body'],
			'time' => timeformat($row['posterTime']),
			'timestamp' => forum_time(true, $row['posterTime']),
			'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.msg' . $row['ID_MSG'] . ';topicseen#new',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.msg' . $row['ID_MSG'] . '#msg' . $row['ID_MSG'] . '">' . $row['subject'] . '</a>',
			'new' => !empty($row['isRead']),
			'new_from' => $row['new_from'],
			'icon' => '<img src="' . $settings[$icon_sources[$row['icon']]] . '/post/' . $row['icon'] . '.gif" align="middle" alt="' . $row['icon'] . '" border="0" />',
		);
	}
	mysql_free_result($request);
	
	//Add Colors to the Output link :)
	if(!empty($colorids)) {
		global $color_profile;
		sp_loadColors($colorids);
		foreach($posts as $k => $p) {
			if(!empty($color_profile[$p['poster']['id']]))
				$profile = $color_profile[$p['poster']['id']];
			if(!empty($profile)) {
				$posts[$k]['poster']['link'] = $profile['link'];
			}
		}
	}

	// Just return it.
	if (empty($posts))
		return $posts;

		echo '
		<table border="0" class="ssi_table">';
		foreach ($posts as $post)
		echo '
			<tr>
				<td align="center" valign="middle" nowrap="nowrap">
				', $post['icon'], '	
				</td>
				<td valign="top" width="%100">
					<a href="', $post['href'], '">', $post['subject'], '</a>
					', $post['new'] ? '' : '<a href="' . $scripturl . '?topic=' . $post['topic'] . '.msg' . $post['new_from'] . ';topicseen#new"><img src="' . $settings['images_url'] . '/' . $context['user']['language'] . '/new.gif" alt="' . $txt[302] . '" border="0" /></a>', '<br />[', $post['board']['link'], ']
				</td>
				<td align="right" nowrap="nowrap">
					', $post['poster']['link'], '<br />', $post['time'], '
				</td>
			</tr>';
		echo '
		</table>';

}

function sp_recentTopics($num_recent = 8)
{
	global $context, $settings, $scripturl, $txt, $db_prefix, $ID_MEMBER;
	global $user_info, $modSettings, $func, $posts;

	$exclude_boards = null;

	if ($num_recent === null)
		$num_recent = isset($_GET['limit']) ? (int) $_GET['limit'] : 1;

	if ($exclude_boards === null && !empty($modSettings['recycle_enable']) && $modSettings['recycle_board'] > 0)
		$exclude_boards = array($modSettings['recycle_board']);
	else
		$exclude_boards = empty($exclude_boards) ? array() : $exclude_boards;

	$stable_icons = array('xx', 'thumbup', 'thumbdown', 'exclamation', 'question', 'lamp', 'smiley', 'angry', 'cheesy', 'grin', 'sad', 'wink', 'moved', 'recycled', 'wireless');
	$icon_sources = array();
	foreach ($stable_icons as $icon)
		$icon_sources[$icon] = 'images_url';

	// Find all the posts in distinct topics.  Newer ones will have higher IDs.
	$request = db_query("
		SELECT
			m.posterTime, ms.subject, m.ID_TOPIC, m.ID_MEMBER, m.ID_MSG, b.ID_BOARD, b.name AS bName,
			IFNULL(mem.realName, m.posterName) AS posterName, " . ($user_info['is_guest'] ? '1 AS isRead, 0 AS new_from' : '
			IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, 0)) >= m.ID_MSG_MODIFIED AS isRead,
			IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, -1)) + 1 AS new_from') . ", LEFT(m.body, 384) AS body, m.smileysEnabled, m.icon
		FROM ({$db_prefix}messages AS m, {$db_prefix}topics AS t, {$db_prefix}boards AS b, {$db_prefix}messages AS ms)
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER)" . (!$user_info['is_guest'] ? "
			LEFT JOIN {$db_prefix}log_topics AS lt ON (lt.ID_TOPIC = t.ID_TOPIC AND lt.ID_MEMBER = $ID_MEMBER)
			LEFT JOIN {$db_prefix}log_mark_read AS lmr ON (lmr.ID_BOARD = b.ID_BOARD AND lmr.ID_MEMBER = $ID_MEMBER)" : '') . "
		WHERE t.ID_LAST_MSG >= " . ($modSettings['maxMsgID'] - 35 * min($num_recent, 5)) . "
			AND t.ID_LAST_MSG = m.ID_MSG
			AND b.ID_BOARD = t.ID_BOARD" . (empty($exclude_boards) ? '' : "
			AND b.ID_BOARD NOT IN (" . implode(', ', $exclude_boards) . ")") . "
			AND $user_info[query_see_board]
			AND ms.ID_MSG = t.ID_FIRST_MSG
		ORDER BY t.ID_LAST_MSG DESC
		LIMIT $num_recent", __FILE__, __LINE__);
	$posts = array();
	$colorids = array();
	while ($row = mysql_fetch_assoc($request))
	{
		$row['body'] = strip_tags(strtr(parse_bbc($row['body'], $row['smileysEnabled'], $row['ID_MSG']), array('<br />' => '&#10;')));
		if ($func['strlen']($row['body']) > 128)
			$row['body'] = $func['substr']($row['body'], 0, 128) . '...';

		// Censor the subject.
		censorText($row['subject']);
		censorText($row['body']);
		
		//Collect the color ids :)
		$colorids[$row['ID_MEMBER']] = $row['ID_MEMBER'];

		if (empty($modSettings['messageIconChecks_disable']) && !isset($icon_sources[$row['icon']]))
			$icon_sources[$row['icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['icon'] . '.gif') ? 'images_url' : 'default_images_url';

		// Build the array.
		$posts[] = array(
			'board' => array(
				'id' => $row['ID_BOARD'],
				'name' => $row['bName'],
				'href' => $scripturl . '?board=' . $row['ID_BOARD'] . '.0',
				'link' => '<a href="' . $scripturl . '?board=' . $row['ID_BOARD'] . '.0">' . $row['bName'] . '</a>'
			),
			'topic' => $row['ID_TOPIC'],
			'poster' => array(
				'id' => $row['ID_MEMBER'],
				'name' => $row['posterName'],
				'href' => empty($row['ID_MEMBER']) ? '' : $scripturl . '?action=profile;u=' . $row['ID_MEMBER'],
				'link' => empty($row['ID_MEMBER']) ? $row['posterName'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['posterName'] . '</a>'
			),
			'subject' => $row['subject'],
			'short_subject' => shorten_subject($row['subject'], 25),
			'preview' => $row['body'],
			'time' => timeformat($row['posterTime']),
			'timestamp' => forum_time(true, $row['posterTime']),
			'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.msg' . $row['ID_MSG'] . ';topicseen#new',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.msg' . $row['ID_MSG'] . '#new">' . $row['subject'] . '</a>',
			'new' => !empty($row['isRead']),
			'new_from' => $row['new_from'],
			'icon' => '<img src="' . $settings[$icon_sources[$row['icon']]] . '/post/' . $row['icon'] . '.gif" align="middle" alt="' . $row['icon'] . '" border="0" />',
		);
	}
	mysql_free_result($request);
	
	//Add Colors to the Output link :)
	if(!empty($colorids)) {
		global $color_profile;
		sp_loadColors($colorids);
		foreach($posts as $k => $p) {
			if(!empty($color_profile[$p['poster']['id']]))
				$profile = $color_profile[$p['poster']['id']];
			if(!empty($profile)) {
				$posts[$k]['poster']['link'] = $profile['link'];
			}
		}
	}

	$context['recent_topics']=$posts;

	// Just return it.
	if (empty($posts))
		return $posts;

		echo '
		<table border="0" class="ssi_table">';
		foreach ($posts as $post)
		echo '
			<tr>
				<td align="center" valign="middle" nowrap="nowrap">
				', $post['icon'], '	
				</td>
				<td valign="top" width="%100">
					<a href="', $post['href'], '">', $post['subject'], '</a>
					', $post['new'] ? '' : '<a href="' . $scripturl . '?topic=' . $post['topic'] . '.msg' . $post['new_from'] . ';topicseen#new"><img src="' . $settings['images_url'] . '/' . $context['user']['language'] . '/new.gif" alt="' . $txt[302] . '" border="0" /></a>', '<br />[', $post['board']['link'], ']
				</td>
				<td align="right" nowrap="nowrap">
					', $post['poster']['link'], '<br />', $post['time'], '
				</td>
			</tr>';
		echo '
		</table>';

}

function sp_boardNews($board = null, $limit = null, $start = null, $length = null, $avatars = 1)
{
	global $scripturl, $db_prefix, $txt, $settings, $modSettings, $context;
	global $func, $return;

	loadLanguage('Stats');

	// Must be integers....
	if ($limit === null)
		$limit = isset($_GET['limit']) ? (int) $_GET['limit'] : 5;
	else
		$limit = (int) $limit;

	if ($start === null)
		$start = isset($_GET['start']) ? (int) $_GET['start'] : 0;
	else
		$start = (int) $start;

	if ($board !== null)
		$board = (int) $board;
	elseif (isset($_GET['board']))
		$board = (int) $_GET['board'];

	if ($length === null)
		$length = isset($_GET['length']) ? (int) $_GET['length'] : 0;
	else
		$length = (int) $length;

	$limit = max(0, $limit);
	$start = max(0, $start);

	// Make sure guests can see this board.
	$request = db_query("
		SELECT ID_BOARD
		FROM {$db_prefix}boards
		WHERE " . ($board === null ? '' : "ID_BOARD = $board
			AND ") . "FIND_IN_SET(-1, memberGroups)
		LIMIT 1", __FILE__, __LINE__);
	if (mysql_num_rows($request) == 0)
	{
		die($txt['smf_news_error2']);
	}
	list ($board) = mysql_fetch_row($request);
	mysql_free_result($request);

	// Load the message icons - the usual suspects.
	$stable_icons = array('xx', 'thumbup', 'thumbdown', 'exclamation', 'question', 'lamp', 'smiley', 'angry', 'cheesy', 'grin', 'sad', 'wink', 'moved', 'recycled', 'wireless');
	$icon_sources = array();
	foreach ($stable_icons as $icon)
		$icon_sources[$icon] = 'images_url';

	// Find the post ids.
	$request = db_query("
		SELECT ID_FIRST_MSG
		FROM {$db_prefix}topics
		WHERE ID_BOARD = $board
		ORDER BY ID_FIRST_MSG DESC
		LIMIT $start, $limit", __FILE__, __LINE__);
	$posts = array();
	while ($row = mysql_fetch_assoc($request))
		$posts[] = $row['ID_FIRST_MSG'];
	mysql_free_result($request);

	if (empty($posts))
		return array();

	// Find the posts.
	$request = db_query("
		SELECT
			m.icon, m.subject, m.body, IFNULL(mem.realName, m.posterName) AS posterName, m.posterTime,
			t.numReplies, t.ID_TOPIC, m.ID_MEMBER, m.smileysEnabled, m.ID_MSG, t.locked, mem.avatar, a.ID_ATTACH, a.attachmentType, a.filename
		FROM ({$db_prefix}topics AS t, {$db_prefix}messages AS m)
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER)
			LEFT JOIN {$db_prefix}attachments AS a ON (a.ID_MEMBER = m.ID_MEMBER)
		WHERE t.ID_FIRST_MSG IN (" . implode(', ', $posts) . ")
			AND m.ID_MSG = t.ID_FIRST_MSG
		ORDER BY t.ID_FIRST_MSG DESC
		LIMIT " . count($posts), __FILE__, __LINE__);
	$return = array();
	$colorids = array();
	while ($row = mysql_fetch_assoc($request))
	{
		// If we want to limit the length of the post.
		if (!empty($length) && $func['strlen']($row['body']) > $length)
		{
			$row['body'] = $func['substr']($row['body'], 0, $length);

			// The first space or line break. (<br />, etc.)
			$cutoff = max(strrpos($row['body'], ' '), strrpos($row['body'], '<'));

			if ($cutoff !== false)
				$row['body'] = $func['substr']($row['body'], 0, $cutoff);
			$row['body'] .= '...';
		}

		$row['body'] = parse_bbc($row['body'], $row['smileysEnabled'], $row['ID_MSG']);
		
		if (stristr($row['avatar'], 'http://') && !empty($modSettings['avatar_check_size']))
		{
			$sizes = url_image_size($row['avatar']);

			// Does your avatar still fit the maximum size?
			if ($modSettings['avatar_action_too_large'] == 'option_refuse' && is_array($sizes) && (($sizes[0] > $modSettings['avatar_max_width_external'] && !empty($modSettings['avatar_max_width_external'])) || ($sizes[1] > $modSettings['avatar_max_height_external'] && !empty($modSettings['avatar_max_height_external']))))
			{
				// Fix it permanently!
				$row['avatar'] = '';
				updateMemberData($row['ID_MEMBER'], array('avatar' => '\'\''));
			}
		}

		// Check that this message icon is there...
		if (empty($modSettings['messageIconChecks_disable']) && !isset($icon_sources[$row['icon']]))
			$icon_sources[$row['icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['icon'] . '.gif') ? 'images_url' : 'default_images_url';

		censorText($row['subject']);
		censorText($row['body']);
		
		//Collect the color ids :)
		$colorids[$row['ID_MEMBER']] = $row['ID_MEMBER'];

		$return[] = array(
			'id' => $row['ID_TOPIC'],
			'message_id' => $row['ID_MSG'],
			'icon' => '<img src="' . $settings[$icon_sources[$row['icon']]] . '/post/' . $row['icon'] . '.gif" align="middle" alt="' . $row['icon'] . '" border="0" />',
			'subject' => $row['subject'],
			'time' => timeformat($row['posterTime']),
			'timestamp' => forum_time(true, $row['posterTime']),
			'body' => $row['body'],
			'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0">' . $row['numReplies'] . ' ' . ($row['numReplies'] == 1 ? $txt['smf_news_1'] : $txt['smf_news_2']) . '</a>',
			'replies' => $row['numReplies'],
			'comment_href' => !empty($row['locked']) ? '' : $scripturl . '?action=post;topic=' . $row['ID_TOPIC'] . '.' . $row['numReplies'] . ';num_replies=' . $row['numReplies'],
			'comment_link' => !empty($row['locked']) ? '' : '<a href="' . $scripturl . '?action=post;topic=' . $row['ID_TOPIC'] . '.' . $row['numReplies'] . ';num_replies=' . $row['numReplies'] . '">' . $txt['smf_news_3'] . '</a>',
			'new_comment' => !empty($row['locked']) ? '' : '<a href="' . $scripturl . '?action=post;topic=' . $row['ID_TOPIC'] . '.' . $row['numReplies'] . '">' . $txt['smf_news_3'] . '</a>',
			'poster' => array(
				'id' => $row['ID_MEMBER'],
				'name' => $row['posterName'],
				'href' => !empty($row['ID_MEMBER']) ? $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] : '',
				'link' => !empty($row['ID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['posterName'] . '</a>' : $row['posterName']
			),
			'locked' => !empty($row['locked']),
			'is_last' => false,
			'avatar' => array(
				'name' => $row['avatar'],
				'image' => $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? '<img src="' . (empty($row['attachmentType']) ? $scripturl . '?action=dlattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) . '" alt="" class="avatar" border="0" />' : '') : (stristr($row['avatar'], 'http://') ? '<img src="' . $row['avatar'] . '" alt="" class="avatar" border="0" />' : '<img src="' . $modSettings['avatar_url'] . '/' . htmlspecialchars($row['avatar']) . '" alt="" class="avatar" border="0" />'),
				'href' => $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? (empty($row['attachmentType']) ? $scripturl . '?action=dlattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) : '') : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar']),
				'url' => $row['avatar'] == '' ? '' : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar']),
			),
		);
	}
	mysql_free_result($request);

	if (empty($return))
		return $return;

	$return[count($return) - 1]['is_last'] = true;
	//Add Colors to the Output link :)
	if(!empty($colorids)) {
		global $color_profile;
		sp_loadColors($colorids);
		foreach($return as $k => $p) {
			if(!empty($color_profile[$p['poster']['id']]))
				$profile = $color_profile[$p['poster']['id']];
			if(!empty($profile)) {
				$return[$k]['poster']['link'] = $profile['link'];
			}
		}
	}

		echo '<br />
		<table cellpadding="0" cellspacing="0" border="0" width="100%" style="clear: both; table-layout: fixed;">';

		foreach ($return as $news)
		{
		echo '
			<tr>';
			if($avatars) {
				$avatar_max_table_width = max($modSettings['avatar_max_width_upload'], $modSettings['avatar_max_width_external']) + 10;
				echo'
					<td width="', $avatar_max_table_width, 'px">', $news['avatar']['image'], '</td>';
			}
			echo '
				<td>
			<div>
				<a href="', $news['href'], '">', $news['icon'], '</a> <b>', $news['subject'], '</b>
				<div class="smaller">', $news['time'], ' ', $txt[525], ' ', $news['poster']['link'], '</div>

				<div class="post" style="padding: 2ex 0;">', $news['body'], '</div>

				', $news['link'], $news['locked'] ? '' : ' | ' . $news['comment_link'], '
			</div>
				</td>
			</tr>';

		if (!$news['is_last'])
			echo '
			<tr>
				<td', $avatars ? ' colspan="2"' : '', '>
					<hr style="margin: 2ex 0;" width="100%" />
				</td>
			</tr>';
		}
		echo '</table>';

}

function sp_smfShop()
{
	global $db_prefix, $context;
	
		// Grab the purchase history
		// Start with empty list
		$context['shop_purchHis'] = array();
		// Get the details of purchases
		$request = db_query("
			SELECT ownerid, itemid, amtpaid, it.desc, it.image, it.id
			FROM {$db_prefix}shop_purchHis, {$db_prefix}shop_items AS it
			WHERE itemid = it.id
			ORDER BY ownerid DESC
			LIMIT 20", __FILE__, __LINE__);
		// Loop through all results
		while ($row = mysql_fetch_array($request, MYSQL_ASSOC))
			// And add them to the list
			$context['shop_purchHis'][] = array(
				'ownerid' => $row['ownerid'],
				'itemid' => $row['itemid'],
				'amtpaid' => $row['amtpaid'],
				'desc' => $row['desc'],
				'image' => $row['image']	
			);
			
		mysql_free_result($request);
		if (!empty($context['shop_purchHis'])) {
		echo '
					<td class="smalltext" height="100%" valign="top" align="center" style="line-height: 1.3;">
					';
		foreach ($context['shop_purchHis'] as $row)
		echo "<img src='{$boardurl}/Sources/shop/item_images/{$row['image']}'title='{$row['desc']}'>&nbsp;&nbsp;";
		}
		else
		echo '<td>Nothing is purchased.';

}

function sp_smfGallery($type = 0)
{
	global $modSettings, $context, $user_info, $scripturl, $sc, $ID_MEMBER, $db_prefix, $GD_Installed, $gallery_picture;

	$GD_Installed = function_exists('imagecreate');

	$dbresult = db_query("
		SELECT p.ID_PICTURE
		FROM {$db_prefix}gallery_pic as p
		ORDER BY ID_PICTURE DESC
		LIMIT 1", __FILE__, __LINE__);

	$max = mysql_fetch_assoc($dbresult);
	$check = 0;

	while($check == 0) {

		if ($type == 0)
			$idpic = rand(1, $max['ID_PICTURE']);
		else
			$idpic = $max['ID_PICTURE'];

		$dbresult = db_query("
			SELECT p.ID_PICTURE, p.commenttotal, p.filesize, p.views, p.thumbfilename, p.filename, p.height, p.width, p.title, p.ID_MEMBER,
		m.memberName, m.realName, p.date, p.description
			FROM {$db_prefix}gallery_pic as p
			LEFT JOIN {$db_prefix}members AS m on ( p.ID_MEMBER = m.ID_MEMBER)
			WHERE p.approved = 1 AND p.ID_PICTURE = $idpic
			ORDER BY ID_PICTURE DESC", __FILE__, __LINE__);
		$gallery_picture = array();
		while($row = mysql_fetch_assoc($dbresult))
			{
				$gallery_picture = array (
					'id' => $row['ID_PICTURE'],
					'title' => $row['title'],
					'views' => $row['views'],
					'senderid' => $row['ID_MEMBER'],
					'sendername' => $row['realName'],
					'thumbfilename' => $row['thumbfilename'],
					'filename' => $row['filename']
				);
			}
		
			mysql_free_result($dbresult);		
	
		if(!empty($gallery_picture) || $type != 0 || empty($max))
			$check = 1;
	}

			if (!empty($gallery_picture)) {
			echo '
							<a href="' . $scripturl . '?action=gallery;sa=view;id=' . $gallery_picture['id'] . '"><img ' . ($GD_Installed == true ?  'src="' . $modSettings['gallery_url'] . $gallery_picture['thumbfilename'] . '" ' : 'src="' . $modSettings['gallery_url'] . $gallery_picture['filename'] . '" height="78" width="120" ')  . ' border="0" /></a>
							<br />' . $gallery_picture['title'] . '<span class="smalltext"><br />
							<b>' . $txt['sp-grpictureviews'] . '</b> ' . $gallery_picture['views'] . '<br />';
				if ($gallery_picture['sendername'] != '')
					echo '<b>' . $txt['sp-grpicturesender'] . '</b> <a href="' . $scripturl . '?action=profile;u=' . $gallery_picture['senderid'] . '">'  . $gallery_picture['sendername'] . '</a><br />';
				else 
					echo '<b>' . $txt['sp-grpicturesender'] . '</b> ' . $txt['sp-grpictureguest'] . '<br />';
			echo '</span>';
			}
			else
				echo 'There is no picture in the gallery.';
}

function sp_smfArcade($topPlayers = 10)
{
	global $boardurl, $sourcedir, $modSettings, $scripturl, $db_prefix, $arcade, $best_players;

	require_once($sourcedir.'/ArcadeStats.php');

	$sql = "SELECT game.ID_GAME, game.gameName, game.thumbnail, game.gameDirectory,
    	    IFNULL(mem.ID_MEMBER, 0) AS ID_MEMBER, IFNULL(mem.realName,'') AS realName, score.score 
        	FROM {$db_prefix}arcade_scores AS score
	        LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = score.ID_MEMBER)
    	    JOIN {$db_prefix}arcade_games AS game ON (game.ID_GAME = score.ID_GAME)
        	ORDER BY `championFrom` DESC
	        LIMIT 0,1";
	if(!($result = db_query($sql,__FILE__,__LINE__)))
	{
		die("Could not get the newest champ");
	}
	$row = mysql_fetch_assoc($result);
	mysql_free_result($result);

	if(isset($row['gameDirectory']))
	{
		$row['gameDirectory']=$row['gameDirectory']."/";
	}
	$arcade = array();
	$arcade = array (
		'playerid' => $row['ID_MEMBER'],
		'player' => $row['realName'],
		'game_id' => $row['ID_GAME'],
		'game_name' => $row['gameName'],
		'score' => $row['score'],
		'game_pic' => $modSettings['gamesUrl'] . "/" . $row['gameDirectory'].$row['thumbnail'],
		);

	$best_players=ArcadeStats_BestPlayers($topPlayers);

	$score_poss=0;

			echo '
<script type="text/javascript">

/***********************************************
* Cross browser Marquee II-  Dynamic Drive (www.dynamicdrive.com)
* This notice MUST stay intact for legal use
* Visit http://www.dynamicdrive.com/ for this script and 100s more.
***********************************************/

var delayb4scrollx=2000 //Specify initial delay before marquee starts to scroll on page (2000=2 seconds)
var marqueespeedx=1 //Specify marquee scroll speed (larger is faster 1-10)
var pauseitx=1 //Pause marquee onMousever (0=no. 1=yes)?

////NO NEED TO EDIT BELOW THIS LINE////////////

var copyspeedx=marqueespeedx
var pausespeedx=(pauseitx==0)? copyspeedx: 0
var actualheightx=\'\'

function scrollmarqueex(){
if (parseInt(cross_marqueex.style.top)>(actualheightx*(-1)+8))
cross_marqueex.style.top=parseInt(cross_marqueex.style.top)-copyspeedx+"px"
else
cross_marqueex.style.top=parseInt(marqueeheightx)+8+"px"
}

function initializemarqueex(){
cross_marqueex=document.getElementById("vmarqueex")
cross_marqueex.style.top=0
marqueeheightx=document.getElementById("marqueecontainerx").offsetHeight
actualheightx=cross_marqueex.offsetHeight
if (window.opera || navigator.userAgent.indexOf("Netscape/7")!=-1){ //if Opera or Netscape 7x, add scrollbars to scroll and exit
cross_marqueex.style.height=marqueeheightx+"px"
cross_marqueex.style.overflow="scroll"
return
}
setTimeout(\'lefttime=setInterval("scrollmarqueex()",30)\', delayb4scrollx)
}

if (window.addEventListener)
window.addEventListener("load", initializemarqueex, false)
else if (window.attachEvent)
window.attachEvent("onload", initializemarqueex)
else if (document.getElementById)
window.onload=initializemarqueex

</script>';

			if(!empty($arcade['game_id'])) {
			echo '
		<div id="marqueecontainerx" style="position: relative; width: 95%; height:200px; overflow: hidden; border: 0px; padding: 2px; padding-left: 4px;" onmouseover="copyspeedx=pausespeedx" onmouseout="copyspeedx=marqueespeedx">
			<div id="vmarqueex" style="position: absolute; width: 98%;">
				<div align="center">
					<a href="',$scripturl,'?action=arcade;sa=play;game=',$arcade['game_id'],'"><img src="',$arcade['game_pic'],'" border="0" alt="',$arcade['game_name'],'" width="60" height="60"/></a>
					<br />',$txt['sp-arcadelate'],'<br />
					<a href="',$scripturl,'?action=profile;u=',$arcade['playerid'],'">',$arcade['player'],'</a>
					<br/>',$txt['sp-arcadewit'],' ',$arcade['score'],' ',$txt['sp-arcadeon'],'<br />',$arcade['game_name'],'
					<br />------------------<br />',$txt['sp-arcadeplay'],'<br /><br />';
					$score_poss = 0;
					foreach ($best_players as $players)
					{
						$score_poss++;
						echo '',$score_poss,' - ',$players['link'],'<br />',$txt['sp-arcadewin'],' ',$players['champions'],'
						     <br /><br />';
					};
	echo '</div>
			</div>
		</div>';
			}
			else
			echo 'There no game installed.';

}

function sp_quickSearch()
{
	global $scripturl, $txt, $context;

	echo '
		<form action="', $scripturl, '?action=search2" method="post" accept-charset="', $context['character_set'], '">
			<div align="center">
			<input type="hidden" name="advanced" value="0" /><input type="text" name="search" size="30" /><br /><input type="submit" name="submit" value="', $txt[182], '" />
			</div>
		</form>';
}

function sp_news()
{
	global $context;

	echo '<div align="center">', $context['random_news_line'], '</div>';
}

function sp_bbc($content = null)
{
	global $context, $scripturl, $txt, $sourcedir;

	require_once($sourcedir . '/Subs.php');

	$content = parse_bbc($content);
	
	echo $content;
}

function sp_html($content = null)
{
	echo $content;
}

function sp_php($content = null)
{
	global $context, $scripturl, $txt;

	eval($content);
}

//This is  a small Skript to load colors for ssi
function sp_loadColors($users = array()) {
	global $color_profile, $db_prefix, $scripturl;

	// Can't just look for no users :P.
	if (empty($users))
		return false;

	// Make sure it's an array.
	$users = !is_array($users) ? array($users) : array_unique($users);

	//First check is it already loaded?
	if(empty($color_profile))
		$color_profile = array();
	else {
		foreach($users as $k => $u)
			if(isset($color_profile[$u]))
				unset($users[$k]);
	}
	
	if (empty($users))
		return false;

	// Load the data.
	$request = db_query("
		SELECT 
		mem.ID_MEMBER, mem.memberName, mem.realName, mem.ID_GROUP,
		mg.onlineColor AS member_group_color, pg.onlineColor AS post_group_color
		FROM {$db_prefix}members AS mem 
		LEFT JOIN {$db_prefix}membergroups AS pg ON (pg.ID_GROUP = mem.ID_POST_GROUP)
		LEFT JOIN {$db_prefix}membergroups AS mg ON (mg.ID_GROUP = mem.ID_GROUP)
		WHERE mem.ID_MEMBER ".(count($users) == 1 ? " = '" . current($users) . "'" : " IN ('" . implode("', '", $users) . "')"), __FILE__, __LINE__);

	$loaded_ids = array();
	while ($row = mysql_fetch_assoc($request))
	{
		$loaded_ids[] = $row['ID_MEMBER'];
		$color_profile[$row['ID_MEMBER']] = $row;
		$color_profile[$row['ID_MEMBER']]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . (!empty($row['member_group_color']) || !empty($row['post_group_color']) ? '<span style="color:'. (!empty($row['member_group_color']) ? $row['member_group_color'] : $row['post_group_color'] ) .';">' : '' ) . $row['realName'] . (!empty($row['member_group_color']) || !empty($row['post_group_color']) ? '</span>' : '' ).'</a>';
	}
	mysql_free_result($request);

	return empty($loaded_ids) ? false : $loaded_ids;
}

?>
