<?php

if (!defined('SMF'))
	die('Hacking attempt...');

/*

getBlockInfo()
getFunctionInfo()
getCategoryInfo()
getArticleInfo()
createArticle()
fixCategoryArticles()
fixColumnRows()
changeBlockRow()
changeState()

*/

function getBlockInfo($column_id = null, $block_id = null, $state = null)
{
	global $scripturl, $context, $db_prefix, $settings;

	$query = array();
	if(!empty($column_id))
		$query[] = "col = '$column_id'";
	if(!empty($block_id))
		$query[] = "ID_BLOCK = '$block_id'";
	if(!empty($state))
		$query[] = "state = '1'";
		
	$request = db_query("
		SELECT ID_BLOCK, label, type, content, parameters, col, row, state
		FROM {$db_prefix}sp_blocks" .
		(!empty($query) ? " WHERE " . implode(' AND ', $query) : "") .
		" ORDER BY row", __FILE__, __LINE__);
	$return = array();
	while ($row = mysql_fetch_assoc($request))
	{

		$return[] = array(
			'id' => $row['ID_BLOCK'],
			'label' => $row['label'],
			'type' => $row['type'],
			'content' => $row['content'],
			'parameters' => $row['parameters'],
			'column' => $row['col'],
			'row' => $row['row'],
			'state' => empty($row['state']) ? '<a href="' . $scripturl . '?action=spadmin;sa=statechange;id=' . $row['ID_BLOCK'] . ';type=block;sesc=' . $context['session_id'] . '"><img src="' . $settings['default_theme_url'] . '/images/icons/package_old.gif" alt="deactive" /></a>' : '<a href="' . $scripturl . '?action=spadmin;sa=statechange;id=' . $row['ID_BLOCK'] . ';type=block;sesc=' . $context['session_id'] . '"><img src="' . $settings['default_theme_url'] . '/images/icons/package_installed.gif" alt="deactive" /></a>',
			'edit' => '<a href="' . $scripturl . '?action=spadmin;sa=blockedit;id=' . $row['ID_BLOCK'] . ';sesc=' . $context['session_id'] . '"><img src="' . $settings['default_theme_url'] . '/images/buttons/modify.gif" alt="modify" /></a>',
			'delete' => '<a href="' . $scripturl . '?action=spadmin;sa=blockdelete;id=' . $row['ID_BLOCK'] . ';col=' . $row['col'] . ';sesc=' . $context['session_id'] . '"><img src="' . $settings['default_theme_url'] . '/images/buttons/delete.gif" alt="delete" /></a>',
			'moveup' => '<a href="' . $scripturl . '?action=spadmin;sa=blockmove;id=' . $row['ID_BLOCK'] . ';direction=up;sesc=' . $context['session_id'] . '"><img src="' . $settings['default_theme_url'] . '/images/sort_up.gif" alt="moveup" /></a>',
			'movedown' => '<a href="' . $scripturl . '?action=spadmin;sa=blockmove;id=' . $row['ID_BLOCK'] . ';direction=down;sesc=' . $context['session_id'] . '"><img src="' . $settings['default_theme_url'] . '/images/sort_down.gif" alt="movedown" /></a>'
		);
	}
	mysql_free_result($request);

	return $return;
}

function getFunctionInfo($function = null)
{
	global $db_prefix;

	$request = db_query("
		SELECT ID_FUNCTION, name, parameter
		FROM {$db_prefix}sp_functions" .
		(!empty($function) ? " WHERE name = '$function'" : "") .
		" ORDER BY ID_FUNCTION ASC", __FILE__, __LINE__);
	$return = array();
	while ($row = mysql_fetch_assoc($request))
	{

		$return[] = array(
			'id' => $row['ID_FUNCTION'],
			'function' => $row['name'],
			'parameter' => $row['parameter'],
		);
	}
	mysql_free_result($request);

	return $return;
}

function getCategoryInfo($category_id = null)
{
	global $scripturl, $context, $db_prefix, $settings;

	$request = db_query("
		SELECT ID_CATEGORY, name, picture, articles, publish
		FROM {$db_prefix}sp_categories" .
		(!empty($category_id) ? " WHERE ID_CATEGORY = '$category_id'" : "") .
		" ORDER BY ID_CATEGORY", __FILE__, __LINE__);
	$return = array();
	while ($row = mysql_fetch_assoc($request))
	{

		$return[] = array(
			'id' => $row['ID_CATEGORY'],
			'name' => $row['name'],
			'picture' => array (
				'href' => $row['picture'],
				'image' => '<img src="' . $row['picture'] . '" alt="' . $row['name'] . '" width="75" />',
			),
			'articles' => $row['articles'],
			'publish' => $row['publish'],
			'edit' => '<a href="' . $scripturl . '?action=spadmin;sa=categoryedit;id=' . $row['ID_CATEGORY'] . ';sesc=' . $context['session_id'] . '"><img src="' . $settings['default_theme_url'] . '/images/buttons/modify.gif" alt="modify" /></a>',
			'delete' => '<a href="' . $scripturl . '?action=spadmin;sa=categorydelete;id=' . $row['ID_CATEGORY'] . ';sesc=' . $context['session_id'] . '"><img src="' . $settings['default_theme_url'] . '/images/buttons/delete.gif" alt="delete" /></a>'
		);
	}
	mysql_free_result($request);

	return $return;
}

function getArticleInfo($article_id = null, $category_id = null, $message_id = null, $approved = null)
{
	global $db_prefix;

	$query = array();
	if(!empty($article_id))
		$query[] = "ID_ARTICLE = '$article_id'";
	if(!empty($category_id))
		$query[] = "ID_CATEGORY = '$category_id'";
	if(!empty($message_id))
		$query[] = "ID_MESSAGE = '$message_id'";
	if(!empty($approved))
		$query[] = "approved = '1'";

	$request = db_query("
		SELECT a.ID_ARTICLE, a.ID_CATEGORY, a.ID_MESSAGE, a.approved, c.name
		FROM {$db_prefix}sp_articles as a
			LEFT JOIN {$db_prefix}sp_categories AS c ON (c.ID_CATEGORY = a.ID_CATEGORY)" .
		(!empty($query) ? " WHERE " . implode(' AND ', $query) : "") .
		" ORDER BY ID_ARTICLE", __FILE__, __LINE__);
	$return = array();
	while ($row = mysql_fetch_assoc($request))
	{

		$return[] = array(
			'article' => array(
				'id' => $row['ID_ARTICLE'],
				'approved' => $row['approved'],
			),
			'category' => array(
				'id' => $row['ID_CATEGORY'],
				'name' => $row['name'],
			),
			'message' => array(
				'id' => $row['ID_MESSAGE'],
			),
		);
	}
	mysql_free_result($request);

	return $return;
}

function createArticle($articleOptions)
{
	global $db_prefix;

	$articleOptions['ID_CATEGORY'] = !empty($articleOptions['ID_CATEGORY']) ? (int) $articleOptions['ID_CATEGORY'] : 0;
	$articleOptions['ID_MESSAGE'] = !empty($articleOptions['ID_MESSAGE']) ? (int) $articleOptions['ID_MESSAGE'] : 0;
	$articleOptions['approved'] = !empty($articleOptions['approved']) ? (int) $articleOptions['approved'] : 0;
		
	$request = db_query("
		SELECT ID_MESSAGE
		FROM {$db_prefix}sp_articles
		WHERE ID_MESSAGE = '$articleOptions[ID_MESSAGE]'
		LIMIT 1", __FILE__, __LINE__);
	list ($exists) = mysql_fetch_row($request);
	mysql_free_result($request);		

	if(empty($articleOptions['ID_CATEGORY']) || empty($articleOptions['ID_MESSAGE']) || $exists)
		return false;
		
	db_query("
		INSERT INTO {$db_prefix}sp_articles
			(ID_CATEGORY, ID_MESSAGE, approved)
		VALUES ('$articleOptions[ID_CATEGORY]', '$articleOptions[ID_MESSAGE]', $articleOptions[approved])", __FILE__, __LINE__);

	db_query("
		UPDATE {$db_prefix}sp_categories
		SET articles = articles + 1
		WHERE ID_CATEGORY = $articleOptions[ID_CATEGORY]
		LIMIT 1", __FILE__, __LINE__);
}

function fixCategoryArticles()
{
	global $db_prefix;

	$categoryList = getCategoryInfo();
	$categoryIds = array();	

	foreach($categoryList as $category)
		$categoryIds[] = $category['id'];

	foreach($categoryIds as $category) {

		$article_count = 0;
	
		$result = db_query("
			SELECT COUNT(*)
			FROM {$db_prefix}sp_articles
			WHERE ID_CATEGORY = $category", __FILE__, __LINE__);
		list ($article_count) = mysql_fetch_row($result);
		mysql_free_result($result);

		db_query("
			UPDATE {$db_prefix}sp_categories
			SET articles = $article_count
			WHERE ID_CATEGORY = $category
			LIMIT 1", __FILE__, __LINE__);
	}
}

function fixColumnRows($column_id = null)
{
	global $db_prefix;

	$blockList = getBlockInfo($column_id);
	$blockIds = array();	

	foreach($blockList as $block)
		$blockIds[] = $block['id'];

	$counter = 0;

	foreach($blockIds as $block) {

		$counter = $counter + 1;
	
		db_query("
			UPDATE {$db_prefix}sp_blocks
			SET row = $counter
			WHERE ID_BLOCK = $block
			LIMIT 1", __FILE__, __LINE__);
	}
}

function changeState($type = null, $id = null)
{
	global $db_prefix;

	if($type == 'block')
		$query = array(
			'column' => 'state',
			'table' => 'blocks',
			'id' => 'ID_BLOCK'
		);
	elseif($type == 'category')
		$query = array(
			'column' => 'publish',
			'table' => 'categories',
			'id' => 'ID_CATEGORY'
		);
	elseif($type == 'article')
		$query = array(
			'column' => 'approved',
			'table' => 'articles',
			'id' => 'ID_ARTICLE'
		);
	else
		return false;
	
	$request = db_query("
		SELECT $query[column]
		FROM {$db_prefix}sp_$query[table]
		WHERE $query[id] = $id
		LIMIT 1", __FILE__, __LINE__);
	list ($state) = mysql_fetch_row($request);
	mysql_free_result($request);

	$state = (int) $state;
	$state = ($state == 1) ? 0 : 1 ;

	db_query("
		UPDATE {$db_prefix}sp_$query[table]
		SET $query[column] = $state
		WHERE $query[id] = $id
		LIMIT 1", __FILE__, __LINE__);
}

?>