<?php

if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
  require_once(dirname(__FILE__) . '/SSI.php');
// Hmm... no SSI.php and no SMF?
elseif (!defined('SMF'))
  die('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

// Articles Table
db_query("CREATE TABLE IF NOT EXISTS {$db_prefix}sp_articles (
  ID_ARTICLE tinyint(4) NOT NULL auto_increment,
  ID_CATEGORY tinyint(4) NOT NULL default 0,
  ID_MESSAGE tinyint(4) NOT NULL default 0,
  approved tinyint(2) NOT NULL default 0,
  PRIMARY KEY  (ID_ARTICLE)
)", __FILE__, __LINE__);

// Blocks Table
db_query("CREATE TABLE IF NOT EXISTS {$db_prefix}sp_blocks (
  ID_BLOCK int(10) unsigned NOT NULL auto_increment,
  label tinytext NOT NULL,
  type text NOT NULL,
  content text NOT NULL,
  parameters tinytext NOT NULL,
  col tinyint(4) unsigned NOT NULL default 0,
  row tinyint(4) unsigned NOT NULL default 0,
  state tinyint(4) NOT NULL default 1,
  PRIMARY KEY  (ID_BLOCK)
)", __FILE__, __LINE__);

// Categories Table
db_query("CREATE TABLE IF NOT EXISTS {$db_prefix}sp_categories (
  ID_CATEGORY int(10) unsigned NOT NULL auto_increment,
  name tinytext NOT NULL,
  picture tinytext NOT NULL,
  articles tinyint(4) NOT NULL default 0,
  publish tinyint(1) NOT NULL default 0,
  PRIMARY KEY  (ID_CATEGORY)
)", __FILE__, __LINE__);

// Functions Table
db_query("CREATE TABLE IF NOT EXISTS {$db_prefix}sp_functions (
  ID_FUNCTION tinyint(4) NOT NULL auto_increment,
  name tinytext NOT NULL,
  parameter tinyint(4) NOT NULL default 0,
  PRIMARY KEY  (ID_FUNCTION)
)", __FILE__, __LINE__);

// Function Settings
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (18, 'sp_php', 0)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (17, 'sp_html', 0)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (16, 'sp_smfGallery', 1)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (15, 'sp_smfArcade', 1)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (14, 'sp_smfShop', 0)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (13, 'sp_news', 0)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (12, 'sp_boardNews', 5)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (11, 'sp_recentTopics', 1)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (10, 'sp_recentPosts', 1)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (9, 'sp_topTopics', 2)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (8, 'sp_topBoards', 1)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (7, 'sp_topPoster', 1)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (6, 'sp_quickSearch', 0)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (5, 'sp_boardStats', 0)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (4, 'sp_showPoll', 1)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (3, 'sp_whosOnline', 0)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (2, 'sp_latestMember', 0)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (1, 'sp_userInfo', 0)", __FILE__, __LINE__);
db_query("INSERT IGNORE INTO {$db_prefix}sp_functions VALUES (19, 'sp_bbc', 0)", __FILE__, __LINE__);

?>